import random
import numpy as np
from models import *

class UnconstrainedOptimizer:
    
    def optimize(self, model):
        """
        Optimizes an unconstrained mathematical program.

        Args:
        - model (UnconstrainedProgram): The program to be minimized.

        Returns:
        - theta (np.ndarray): The optimized parameter vector.
        """
        pass
    
class NewtonsMethod(UnconstrainedOptimizer):
    
    def __init__(self, num_epochs=100, epsilon=1e-3, tau0=1.0, alpha=0.5, beta=0.5):
        self.num_epochs = num_epochs
        self.epsilon = epsilon
        self.tau0 = tau0
        self.alpha = alpha
        self.beta = beta
    
    def optimize(self, model, X_test=None, y_test=None):
        # TODO: implement this
    
class ConstrainedOptimizer:
    
    def optimize(self, model):
        """
        Optimizes an constrained mathematical program.

        Args:
        - model (ConstrainedProgram): The program to be minimized.

        Returns:
        - theta (np.ndarray): The optimized parameter vector.
        """
        pass

class LogBarrierMethod(ConstrainedOptimizer):
    
    def __init__(self, mu=10, t0=1, delta=1e-6, num_epochs=100, epsilon=1e-3, tau0=1.0, alpha=0.5, beta=0.5):
        self.mu = mu
        self.t0 = t0
        self.delta = delta        
        self.num_epochs = num_epochs
        self.epsilon = epsilon
        self.tau0 = tau0
        self.alpha = alpha
        self.beta = beta

    def optimize(self, model):
        # TODO: implement this